'-----------------------------------------------------------------------------------------
'name                     : ATTINY26L_control.bas
'copyright                : (c)danzup; v.s.
'purpose                  : Cotroller for preamplifier
'micro                    : ATTINY26L
'version                  : 1.0
' RC5 remote control and motorized alps volume potentiometer
'-----------------------------------------------------------------------------------------
$regfile = "attiny26.dat"
$crystal = 8000000
$hwstack = 40
$swstack = 16
$framesize = 32
Config Porta.6 = Output                                     'Power relay
Config Porta.7 = Output                                     'LED on/off
Config Portb = Output


'config buttons all buttons low and trigger if high
Config Porta.0 = Input                                      'power on/off
Config Porta.1 = Input                                      'volume up
Config Porta.2 = Input                                      'volume down
Porta.0 = 0                                                 'low pin must be set high to trigger  button to VCC
Porta.1 = 0
Porta.2 = 0

Dim Address As Byte , Command As Byte                       'RC5 IR variable
Dim W As Word
Dim Inp_sel As Word
Dim Pwr As Bit
Pwr = 1                                                     '0 =stand-by ; 1 = power on
Set Porta.pa6                                               'POWER RELAY ON
Set Porta.pa7                                               'LED OFF
Declare Sub Volup
Declare Sub Voldn
Declare Sub Pwronof
Declare Sub Poweron
Declare Sub Poweroff
Config Timer1 = Timer , Prescale = 1024
Stop Timer1
Config Rc5 = Pina.2                                         'pin where is conected IR senzor
Portb = &B01110000                                          ' PORTB.2 and PORTB.3 MOTOR CONTROL/ALPS
Enable Interrupts
Start Timer1

Do
If Pwr = 1 Then
   W = Timer1
   If W => 100 Then
      Set Portb.pb3
      Set Portb.pb2
   End If
   Getrc5(address , Command)                                'Read remote IR command is presented
   If Address = 20 Then
      Command = Command And &B01111111
      Reset Porta.pa6
   End If
   Select Case Command
 '-----RC5 REMOTE CODE COMANDS-----
   Case 32 : Call Volup                                     'Remote command code for Vol +
   Case 33 : Call Voldn                                     'Remote command code for Vol -
   Case 160 : Call Volup                                    'Remote command code for Vol +
   Case 161 : Call Voldn                                    'Remote command code for Vol -
   Case 140 : Call Pwronof                                  'STANDBY MODE'
   Case 12 : Call Pwronof                                   'STANDBY MODE'
   Case Else : Set Porta.pa6
 End Select

 'POWER ON OFF BUTTON Button to VCC (high)
 If Pina.0 = 1 Then
    Call Pwronof
    Waitms 500
  End If
 'Volume UP puls HIGH
 If Pina.1 = 1 Then
    Call Volup
    Bitwait Pina.1 , Reset
  End If
 'Volume DOWN puls HIGH
 If Pina.2 = 1 Then
    Call Voldn
    Bitwait Pina.2 , Reset
  End If

End If

If Pwr = 0 Then
   Getrc5(address , Command)                                'Read remote IR command is presented
   If Address = 8 Then
      Command = Command And &B01111111
   End If
   Select Case Command
   Case 140 : Call Pwronof
   Case 12 : Call Pwronof
   End Select

 'POWER ON OFF BUTTON Button to VCC (high)
 If Pina.0 = 1 Then
    Call Pwronof
    Waitms 500
  End If
End If


Loop
End
'-------VOLUME UP-------------
Sub Volup:
   W = 0
   Timer1 = W
   Reset Portb.pb3
   Waitms 20
   Set Porta.pa6
End Sub
'--------VOLUME DOWN----------
Sub Voldn:
   W = 0
   Timer1 = W
   Reset Portb.pb2
   Waitms 20
   Set Porta.pa6
End Sub
'-----------POWER ON/OFF-----------------
Sub Pwronof:
   Pwr = Not Pwr
   If Pwr = 1 Then
      Call Poweron
   Else
      Call Poweroff
   End If
End Sub
'------POWER ON------------------------
Sub Poweron:
   Set Porta.pa6                                               'POWER RELAY ON
   Set Porta.pa7                                               'LED OFF
   Waitms 300
End Sub
'-------POWER OFF----------------------
Sub Poweroff:
   Reset Porta.pa6                                             'POWER RELAY OFF
   Reset Porta.pa7                                             'LED ON
   Waitms 300
End Sub